﻿Rep2 = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0")
Rep2:RegisterDB("Rep2DB")
Rep2:RegisterDefaults("profile", {
	frame = 1,
} )

local factionVars = {}
local c = {
	white = "|cffffffff",
	yellow = "|cffffff78",
	orange = "|cffff7831",
	resume = "|r",
}

local standingmax = 8
local standingmin = 1

local options = {
	type = "group",
	desc = "Displays reputation gains.",
	args = {
		set = {
			type = "text",
			name = "set",
			desc = "Set the output chatframe.",
			get = function()
				return Rep2.db.profile.frame
			end,
			set = "SetChatFrame",
			usage = "ChatFrame#",
		},
	},
}

function Rep2:OnInitialize()
	self:RegisterChatCommand( {"/rep2", "/r2"}, options)
end

function Rep2:OnEnable()
	self:RegisterEvent("MEETINGSTONE_CHANGED", "ScanFaction")
	self:ScanFaction()
end

function Rep2:SetChatFrame(frameNum)
	frameNum = tonumber(frameNum)

	if frameNum then
		local framename = "ChatFrame" .. frameNum
		local chatframe = getglobal(framename)

		if chatframe then
			self:Print("Now using " .. framename)
			chatframe:AddMessage(c.yellow .. "Rep2: " .. c.white .. "Using this chat frame for reputation messages now!")

			self.db.profile.frame = frameNum;
		else
			self:Print(framename .. " is not a valid ChatFrame!")
		end
	end
end

function Rep2:ScanFaction()
	for i = 1, GetNumFactions() do
		local name, _, standingID, _, _, barValue = GetFactionInfo(i)

		factionVars[name] = {}
		factionVars[name].Value = barValue
		factionVars[name].Standing = standingID
	end

	self:RegisterEvent("UPDATE_FACTION")
end

function Rep2:UPDATE_FACTION()
	local chatframe = getglobal("ChatFrame" .. self.db.profile.frame)

	for factionIndex = 1, GetNumFactions() do
		local name, _, standingID, barMin, barMax, barValue, _, _, isHeader = GetFactionInfo(factionIndex)

		if (not isHeader) and factionVars[name] then
			local diff = barValue - factionVars[name].Value

			if diff ~= 0 then
				if standingID ~= factionVars[name].Standing then
					local newfaction = getglobal("FACTION_STANDING_LABEL" .. standingID)
					local newstandingtext =
						"New standing with " .. c.yellow .. name .. c.resume ..
						" is " .. c.yellow .. newfaction .. c.resume .. "!"

					chatframe.AddMessage(newstandingtext)
				end

				local remaining, nextstanding, plusminus
				if diff > 0 then
					plusminus = "+"
					remaining = barMax - barValue
					if standingID < standingmax then
						nextstanding = getglobal("FACTION_STANDING_LABEL" .. standingID + 1)
					else
						nextstanding = "End of " .. getglobal("FACTION_STANDING_LABEL" .. standingmax)
					end
				else
					plusminus = "-"
					remaining = barValue - barMin
					if standingID > standingmin then
						nextstanding = getglobal("FACTION_STANDING_LABEL" .. standingID - 1)
					else
						nextstanding = "Beginning of " .. getglobal("FACTION_STANDING_LABEL" .. standingmin)
					end
				end

				local change = abs(barValue - factionVars[name].Value)
				local repetitions = math.ceil(remaining / change)

				local newvaluetext =
					c.orange .. plusminus .. change .. c.yellow .. " " .. name .. c.resume .. ", " ..
					c.orange .. remaining .. c.resume .. " more to " .. c.yellow .. nextstanding .. c.resume ..
					" (" .. c.orange .. repetitions .. c.resume .. " Repetitions)."

				chatframe:AddMessage(newvaluetext)

				factionVars[name].Value = barValue
				factionVars[name].Standing = standingID
			end
		end
	end
end
